#!/bin/sh
[ ]; [ -f ~/.cache/fennel-1.1.0.lua ]] || curl -s https://fennel-lang.org/downloads/fennel-1.1.0 > ~/.cache/fennel-1.1.0.lua
[ ]; lua ~/.cache/fennel-1.1.0.lua $0 | toot post --quiet -u libc@botsin.space
[ ]; exit

;; This is free and unencumbered software released into the public domain.
;; 
;; Anyone is free to copy, modify, publish, use, compile, sell, or
;; distribute this software, either in source code form or as a compiled
;; binary, for any purpose, commercial or non-commercial, and by any
;; means.
;; 
;; In jurisdictions that recognize copyright laws, the author or authors
;; of this software dedicate any and all copyright interest in the
;; software to the public domain. We make this dedication for the benefit
;; of the public at large and to the detriment of our heirs and
;; successors. We intend this dedication to be an overt act of
;; relinquishment in perpetuity of all present and future rights to this
;; software under copyright law.
;; 
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
;; EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
;; MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
;; IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR
;; OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
;; ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
;; OTHER DEALINGS IN THE SOFTWARE.
;; 
;; For more information, please refer to <http://unlicense.org/>

(fn pick-random [l]
  (. l (math.random 1 (length l))))

(local lexemes
       [
        false
        "lib"
        "n"
        "f"
        "v"
        "p"
        "l"
        "r"
        "s"
        "c"
        "m"
        "u"
        "x"
        "a"
        "g"
        "y"
        "e"
        "i"
        "b"
        "yy"
        "alloc"
        "mem"
        "str"
        "len"
        "cmp"
        "cpy"
        "open"
        "print"
        "dup"
        "dl"
        "move"
        "tok"
        "stat"
        "exec"
        "jmp"
        "set"
        "put"
        "get"
        "env"
        "exit"
        "fmt"
        "ctl"
        "io"
        "std"
        "fork"
        "sig"
        "read"
        "write"
        "int"
        "long"
        "short"
        "char"
        "mk"
        "rand"
        "init"
        "_"
        "__"
        "asm"
        "brk"
        "chr"
        "spn"
        "cat"
        "to"
        "err"
        "no"
        "def"
        "addr"
        "ar"
        "mv"
        "tar"
        "cp"
        "dd"
        "du"
        "xz"
        "zzz"
        "vi"
        "od"
        "ls"
        "sh"
        "awk"
        "bin"
        "shr"
        "shl"
        "ror"
        "rol"
        "int"
        "mov"
        "add"
        "sub"
        "mul"
        "push"
        "pop"
        "dec"
        "jnz"
        "jne"
        "call"
        "crc"
        "xchg"
        "hlt"
        "aaa"
        "aas"
        "dec"
        "cli"
        "cld"
        "clc"
        "cwb"
        ])

(local suffixes
       ["()"
        ".h"
        "_t"
        ])

(math.randomseed (os.time))

(local m (math.random 6 20)) ; TODO: normal distribution
(var r "")
(var x "")
(while (and x (<= (length (.. r x)) m))
  (set r (.. r x))
  (set x (pick-random lexemes)))

(print (.. r (pick-random suffixes)))
